<script>
import { GlLink } from '@gitlab/ui';
import BaseMessage from './base.vue';
import { mapActions, mapState } from 'pinia';
import { useMainStore } from '../../../../stores/main';

export default {
  components: {
    BaseMessage,
    GlLink,
  },
  props: {
    message: {
      required: true,
      type: Object,
    },
  },
  provide: {
    renderGFM: (element, role) => {
      element.classList.add('gl-markdown', 'gl-compact-markdown');
      element.classList.add('duo-system-message', 'gl-text-sm');
    },
  },
  computed: {
    messageFilePath() {
      return this.message.tool_info?.args?.file_path;
    },
  },
  methods: {
    ...mapActions(useMainStore, ['openFile']),
    onOpenFilePath() {
      this.openFile(this.messageFilePath);
    },
  },
};
</script>
<template>
  <base-message :message="message">
    <template #message="{ content }">
      <span>{{ content }}</span>
      <gl-link
        v-if="messageFilePath"
        class="gl-markdown file-path-link"
        data-testid="file-path-link"
        @click.prevent="onOpenFilePath"
      >
        <code>{{ messageFilePath }}</code>
      </gl-link>
    </template>
  </base-message>
</template>
